//+------------------------------------------------------------------+
//|                                             Price Oscillator.mq4 |
//|                                              Skvorsov Konstantin |
//|                                                    skvkv@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Skvorsov Konstantin"
#property link      "skvkv@mail.ru"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Silver
#property indicator_color2 Yellow
//---- indicator parameters
extern int SignalPeriod=5;
//---- indicator buffers
double TrendBuffer[];
double Signal[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators setting
   SetIndexBuffer(0,TrendBuffer);
   SetIndexBuffer(1,Signal);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
//---- name for DataWindow and indicator subwindow label
   SetIndexLabel(0,"BB");
   SetIndexLabel(1,"Signal");
//   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   IndicatorShortName("B");  
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  { double ma5,ma20;
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for(int i=0; i<limit; i++)
      {
      ma5=iMA(NULL,0,19,0,MODE_EMA,PRICE_CLOSE,i);
      ma20=iMA(NULL,0,39,0,MODE_EMA,PRICE_TYPICAL,i);
      TrendBuffer[i]=(ma5-ma20)/ma5*100;
      }
   for(i=0; i<limit; i++) 
      Signal[i]=iMAOnArray(TrendBuffer,0,SignalPeriod,0,MODE_SMA,i);
   
   return(0);
  }
//+------------------------------------------------------------------+